/*PROGRAM NAME : MD1.PRG*/

output file = c:\gauss\gaussprc\str\quarter\test_k.out reset;

/* sample range is 1970:1 to 1999:3 */
load av[184,6] = c:\gauss\gaussprc\str\data\quarter.prn;

i=0;
do until i==6;
i = i + 1;

if i==1;
iip = av[100:184,5];
m1  = av[100:184,2];
m2  = av[100:184,1];
cr  = av[100:184,6];
cpi = av[100:184,3];
"Sampling period: 1980:1-2001:1";
elseif i==2;
iip = av[120:184,5];
m1  = av[120:184,2];
m2  = av[120:184,1];
cr  = av[120:184,6];
cpi = av[120:184,3];
"Sampling period: 1985:1-2001:1";
elseif i==3;
iip = av[1:184,5];
m1  = av[1:184,2];
m2  = av[1:184,1];
cr  = av[1:184,6];
cpi = av[1:184,3];
"Sampling period: 1955:2-2001:1";
elseif i==4;
iip = av[1:176,5];
m1  = av[1:176,2];
m2  = av[1:176,1];
cr  = av[1:176,6];
cpi = av[1:176,3];
"Sampling period: 1955:2-1999:1";
elseif i==5;
iip = av[100:176,5];
m1  = av[100:176,2];
m2  = av[100:176,1];
cr  = av[100:176,6];
cpi = av[100:176,3];
"Sampling period: 1980:1-1999:1";
elseif i==6;
iip = av[120:176,5];
m1  = av[120:176,2];
m2  = av[120:176,1];
cr  = av[120:176,6];
cpi = av[120:176,3];
"Sampling period: 1985:1-1999:1";
endif;


/*  setting dependet and independent variables   */
lrm1 = ln(m1)-ln(cpi);
lrm2 = ln(m2)-ln(cpi);
liip = ln(iip);
lcr  = ln(cr);


/*Detrending IIP */
t       = rows(liip);
d_iip   = liip-lag1(liip);                 /* Setting up innovations of IIP */
drift   = meanc(trimr(d_iip,1,0));         /* Setting up drift of IIP */
dtr_iip = liip-drift.*SEQA(1,1,t);


@  COMPUTE WALD TESTS  @

"Nonlinear effect of intrerest rate on intrerest rate";
y   = lrm1-liip;
x   = cr;
ex1 = cr.*cr;
ex2 = ex1~cr.*cr.*cr;
T11 = AXLL(0,1,X,EX1,Y);
T12 = AXLL(0,2,X,EX1,Y);
T13 = AXLL(0,4,X,EX1,Y);
T14 = AXLL(0,8,X,EX1,Y);
T21 = AXLL(0,1,X,EX2,Y);
T22 = AXLL(0,2,X,EX2,Y);
T23 = AXLL(0,4,X,EX2,Y);
T24 = AXLL(0,8,X,EX2,Y);

"T1 test";
t11;;t12;;t13;;t14;
if t11 >= 3.84;
"1";
endif;
if t12 >= 3.84;
"2";
endif;
if t13 >= 3.84;
"3";
endif;
if t14 >= 3.84;
"4";
endif;

"T2 test";
t21;;t22;;t23;;t24;
if t21 >= 5.99;
"1";
endif;
if t22 >= 5.99;
"2";
endif;
if t23 >= 5.99;
"3";
endif;
if t24 >= 5.99;
"4";
endif;
"";
endo;
END;


/* Auxiliary leads-and-lags regression for nonlinearity tests

    PROCEDURE NAME : AXLL.G                                            */

 PROC (1) = AXLL(PT,K,Z,EZ,Y);

   @ Model: y = z*g + ez*d + u @

/* PT = -1 (no intrercept), 0 (intrercept),1 (intrercept + lin. time trend)
   K: maximum no. of leads or lags, Z: regressor under the null of linearity,
   EZ: regressor from expansion
   Y:regressand  */
/* Leads-and-lags of z are added. */

/* RETURNS WALD TEST */

    LOCAL N,M1,M2,A,B,Y_, X,EX, Z_,I,ZZA,ZZN,GAMA,GAMN,
                   L,Q,INTER,TREND,RESID,IVC,IZ,COE,R1,R2,LQ,LVAR,DEL,WALD;

    N = ROWS(Y);
    M1 = COLS(Z);
    M2 = COLS(EZ);

    A = N - 2*K -1;
    B = M1*(2*K+1);
    Z_ = ONES(A,B);
    INTER = ONES(A,1);
    TREND = SEQA(1,1,A);

@ GENERATE REGRESSORS @

    Y_ = Y[K+2:N-K,.];
    X = Z[K+2:N-K,.];
    EX = EZ[K+2:N-K,.];

    I=0;
    DO UNTIL I==2*K+1;
    I = I + 1;

    Z_[1:A,(I-1)*M1+1:I*M1]
        = Z[2*K+2-(I-1):N-(I-1),.] - Z[2*K+2-I:N-I,.];

    ENDO;

    IF PT == -1;

        ZZA = X~Z_~EX;
        ZZN = X~Z_;

    ELSEIF PT == 0;

        ZZA = INTER~X~Z_~EX;
        ZZN = INTER~X~Z_;

    ELSE;

        ZZA = INTER~TREND~X~Z_~EX;
        ZZN = INTER~TREND~X~Z_;

    ENDIF;


@ OLS UNDER THE ALTERNATIVE @

GAMA = INV(ZZA'ZZA)*ZZA'Y_;
IZ = INV(ZZA'ZZA);
IVC = IZ[PT+1+M1+1+M1*(2*K+1):PT+1+M1+M2+M1*(2*K+1),
         PT+1+M1+1+M1*(2*K+1):PT+1+M1+M2+M1*(2*K+1)];
DEL = GAMA[PT+1+M1+1+M1*(2*K+1):PT+1+M1+M2+M1*(2*K+1)];

@ OLS UNDER THE NULL @

GAMN =  INV(ZZN'ZZN)*ZZN'Y_;
RESID = Y_ - ZZN*GAMN;
{COE,R1,R2} = AR4(RESID);
LQ = ABEL4Q(ROWS(RESID),COE);
LVAR = LVEQS(RESID,LQ);

@ LONG-RUN VARIANCE @

WALD = DEL'INV(LVAR*IVC)*DEL;

    RETP(WALD);

ENDP;

/* ABEL4Q.G */
/* AUTOMATIC BAND WIDTH ESTIMATOR WITH AN AR(4) APPROXIMATION */
/* QS WINDOW */
      PROC(1) = ABEL4Q(T,C);
      LOCAL ALPHA;

   ALPHA = 4.*((C[1]*C[2] + 4.*C[1]*C[3] + 9.*C[1]*C[4] + C[2]*C[3]
    + 4.*C[2]*C[4] + C[3]*C[4] - C[1] - 4.*C[2] - 9.*C[3] - 16.*C[4])^2)
    /((C[1] + C[2] + C[3] + C[4] - 1.)^4);
   ALPHA = 1.3221*((ALPHA*T)^.2);

   RETP(ALPHA);
   ENDP;

/* ar4.g */

    /* This program estiamtes ar(4) processes.*/

proc(3) = ar4(x);

local t,y,y1,y2,y3,y4,i,z,izz,est,res,var,vcm;


t = rows(x) - 4;
y = zeros(t,1);
y1 = zeros(t,1);
y2 = zeros(t,1);
y3 = zeros(t,1);
y4 = zeros(t,1);
izz = zeros(4,4);

i = 0;
do until i==t;
i = i + 1;
    y[i] = x[i+4];
    y1[i] = x[i+3];
    y2[i] = x[i+2];
    y3[i] = x[i+1];
    y4[i] = x[i];
endo;

z = y1~y2~y3~y4;
izz = inv(z'z);
est = izz*z'y;
res = y - z*est;
var = res'res/(t-4);
vcm = var*izz;

retp(est,vcm,res);
endp;

/* THIS SUBROUTINE CALCULATES THE LONG VARIANCE OF A TIME SERIES USING  THE QS WINDOW.*/

      PROC  LVEQS(U,L);

      LOCAL LVAR,N,JS,KR,SUM,WS,LP,KJ,X;


      N = ROWS(U);
      LVAR = 0;
      LVAR = U'U/N + LVAR;

      JS = 0;
      DO UNTIL JS== n-1;
      JS = JS + 1;
         SUM = 0.;
         KR = 0;
         LP = N-JS;
         DO UNTIL KR== LP;
         KR = KR + 1;
         KJ = KR+JS;
         SUM = SUM + U[KJ]*U[KR];
         ENDO;

         X=JS/L;
         WS = (25/(12*PI*PI*X*X))*( SIN(6*PI*X/5)/(6*PI*X/5) - COS(6*PI*X/5) );

      LVAR = LVAR + 2.*SUM*WS/N;
      ENDO;

      RETP(LVAR);
      ENDP;

/* THIS PROCEDURE COMPUTES THE EMPIRICAL POWER. THE TEST IS RIGHT ONE-SIDED.*/

        PROC(1) = UPR(TEST,CV);

        LOCAL ICOUNTT,J,N,POW;

            ICOUNTT = 0;
            N = ROWS(TEST);

            J = 0;
            DO UNTIL J==N;
            J = J + 1;

             IF TEST[J] >= CV;
             ICOUNTT = ICOUNTT + 1;
             ENDIF;
            ENDO;

           POW = ICOUNTT/N;

           RETP(POW);
           ENDP;

/*  MASEQ.G
*   obtain MA(1) series with e(0) = 0
*   u(t) = e(t) + Ae(t-1)
*   u(t) = nx1 series generated
*   e(t) = nx1 random disturbances
*   A    = nxn coefficient matrix
*/

proc maseq(a,e);
  local  u, t, n, i;

/* dimension of input/output */

  n = rows(a); n = cols(a);
  t = rows(e);
  n = cols(e);
  u = zeros(t,n);

/* construct MA(1) series */

 u[1,.] = e[1,.];
 i = 2; do while i le t;
 u[i,.] = e[i,.] + e[i-1,.]*a';
 i = i + 1;
 endo;


/* return output */

 retp(u);

 endp;













